<?php
$decodeData = false;
if($_SERVER["REQUEST_METHOD"] == "POST")
{
	include_once("em4xlib.php");
	if(isset($_POST["decodeTag"]) && isset($_POST["mancode"]))
	{
		$data = $_POST["mancode"];
		$decodeData = decodeEM4x($data);
	}
	
	if(isset($_POST["tagIDEncode"]) && isset($_POST["manID"]))
	{
		$data = $_POST["tagIDEncode"];
		
		if(isset($_POST["manID"]) && !empty($_POST["manID"]))
		{
			$decodeData = encodeEM4x($data,$_POST["manID"]);
		}
		else
		{
			$decodeData = encodeEM4x($data);
		}
	}
}

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!--
Design by Free CSS Templates
http://www.freecsstemplates.org
Released for free under a Creative Commons Attribution 2.5 License

Name       : Hand Crafted  
Description: A two-column, fixed-width design with dark color scheme.
Version    : 1.0
Released   : 20120401

-->
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta name="keywords" content="" />
<meta name="description" content="" />
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<title>EM410x Encoder/Decoder</title>
<link href="http://fonts.googleapis.com/css?family=Arvo" rel="stylesheet" type="text/css" />
<link href="http://fonts.googleapis.com/css?family=Coda:400,800" rel="stylesheet" type="text/css" />
<link href="style.css" rel="stylesheet" type="text/css" media="screen" />
<script src="http://ajax.googleapis.com/ajax/libs/jquery/1.4.2/jquery.min.js"></script>
<script type="text/javascript">
	 $(document).ready(function(){
	   // Your code here
	 });
	function loadDecodeSample()
	{
		$('#tagID').val('8069848');
		$('#mancode').val('1 0 1 1 0 1 0 0 0 1 0 0 0 1 1 1 0 1 0 0 1 1 0 0 0 0 0 0 0 0 0 1 1 1 1 1 0 0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0 0 0 1 0 0 0 1 1 0 1 0 1 1 0 1 0 0 0 1 0 0 0 1 1 1 0 1 0 0 1 1 0 0 0 0 0 0 0 0 0 1 1 1 1 1 0 0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0 0 0 1 0 0 0 1 1 0 1 0 1 1 0 1 0 0 0 1 0 0 0 1 1 1 0 1 0 0 1 1 0 0 0 0 0 0 0 0 0 1 1 1 1 1 0 0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0 0 0 1 0 0 0 1 1 0 1 0 1 1 0 1 0 0 0 1 0 0 0 1 1 1 0 1 0 0 1 1 0 0 0 0 0 0 0 0 0 1 1 1 1 1 0 0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0 0 0 1 0 0 0 1 1 0 1 0 1 1 0 1 0 0 0 1 0 0 0 1 1 1 0 1 0 0 1 1 0 0 0 0 0 0 0 0 0 1 1 1 1 1 0 0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0 0 0 1 0 0 0 1 1 0 1 0 1 1 0 1 0 0 0 1 0 0 0 1 1 1 0 1 0 0 1 1 0 0 0 0 0 0 0 0 0 1 1 1 1 1 0 0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0 0 0 1 0 0 0 1 1 0 1 0 1 1 0 1 0 0 0 1 0 0 0 1 1 1 0 1 0 0 1 1 0 0 0 0 0 0 0 0 0 1 1 1 1 1 0 0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0 0 0 1 0 0 0 1 1 0 1 0 1 1 0 1 0 0 0 1 0 0 0 1 1 1 0 1 0 0 1 1 0 0 0 0 0 0 0 0 0 1 1 1 1 1 0 0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0 0 0 1 0 0 0 1 1 0 1 0 1 1 0 1 0 0 0 1 0 0 0 1 1 1 0 1 0 0 1 1 0 0 0 0 0 0 0 0 0 1 1 1 1 1 0 0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0 0 0 1 0 0 0 1 1 0 1 0 1 1 0 1 0 0 0 1 0 0 0 1 1 1');
	}
	
	function loadEncodeSample()
	{
		$('#tagIDEncode').val('8069848');
		$('#manID').val('0f');
	}
</script>
</head>
<body>

<div id="header-wrapper">
	<div id="header">
		<div id="logo">
			<h1><a href="index.php">EM410x <span>Encoder/Decoder</span></a></h1>
		</div>
	</div>
</div>
<div id="wrapper">
	<div id="page">
		<div id="page-bgtop">
			<div id="page-bgbtm">
				<div id="content">
					<div class="post">
						
						<?php
							$x=0;
							if($decodeData != false)
							{
								echo '<h2 class="title"><a href="#">EM41X Decode Results </a></h2>';
								foreach($decodeData as $d)
								{
									
									echo "<div class=\"entry\"><p>
									<table>
									
									";
									$hexUID = false;
									if((isset($_POST["tagID"]) && !empty($_POST["tagID"])) || isset($d["tag"]))
									{
										$t = "";
										if(isset($d["tag"]))
										{
											$t = $d["tag"];
										}
										else
										{
											$t = $_POST["tagID"];
										}
										$hexUID = dechex($t);
										echo "<tr><td><strong>[+] Tag ID:</strong></td><td>$t (dec) / <strong>$hexUID</strong> (hex)</td></tr>";
									}
									if( $hexUID !== false && strpos($d["hex"],$hexUID) !== false)
									{
										$d["hex"] = str_replace($hexUID,"<strong>$hexUID</strong>",$d["hex"]);
									}
									echo "<tr><td><strong>[+] Hex:</strong></td><td>{$d["hex"]}</td></tr>";
									echo "<tr><td><strong>[+] Binary:</strong></td><td> {$d["binary"]}</td></tr>";
									echo "<tr><td><strong>[+] Full Binary:</strong></td><td> {$d["full"]}</td></tr>";
									echo "<tr><td><strong>[+] Full Invert:</strong></td><td> {$d["invert"]}</td></tr>";
									if($d["parityPass"] == True)
										echo "<tr><td><strong>[+] Parity Pass:</strong></td><td class='tdY'>OK!</td></tr>";
									else
										echo "<tr><td><strong>[+] Parity Pass:</strong></td><td  class='tdN'>FAILED!</td></tr>";
									
									
									$x++;
									echo "
									</table><br/>
									<a href='#' onclick=\"$('#Table$x').toggle();return false;\">Show/Hide Data Block...</a><br/><br/>";
									echo
									"
									<div id='Table$x' style='display:none;'>
									<h3>Legend:</h3>
									<table>
									<tr>
										<td class='tdS'>&nbsp;</td><td>Stop Bit</td><td class='tdP'>&nbsp;</td><td>Parity Bit</td><td class='tdY'>&nbsp;</td><td>Parity Pass</td><td class='tdN'>&nbsp;</td><td>Parity Fail</td>
									</tr>
									</table>
									<br/>
									";
									echo "
									<table class='dataTable' >";
									$rowNum = 0;
									foreach($d["data"] as $r)
									{
										$rowNum++;
										echo "<tr>";
											$fieldNum = 0;
											foreach($r as $f)
											{
												$fieldNum++;
												if($rowNum == 11 || $fieldNum == 5 )
												{
													if($rowNum == 11 && $fieldNum == 5)
														echo "<td class='tdS'>$f</td>";
													else
														echo "<td class='tdP'>$f</td>";
													
												}
												else
												{
													echo "<td class='td$f'>$f</td>";
												}
											}
										echo "</tr>";
									}
									echo "</table></div></p></div>";
								}
							}
						?>
						<h2 class="title"><a href="#">EM41X Decoder/Encoder </a></h2>
						
						<div style="clear: both;">&nbsp;</div>
						<div class="entry">
							<p>
								<strong>Decode</strong><br/>
								Simply enter the manchester encoded output in the fields to the left. If your tag has a number on it, enter that into the Tag ID field as well.
								<br/>
								<a href='#' onclick='loadDecodeSample()'>Load Sample</a>
								<br/><br/>
								<strong>Encode</strong><br/>
								Enter the tag ID (on the tag) and the manufacturer ID in the fields on the left.
								<br/>
								<a href='#' onclick='loadEncodeSample()'>Load Sample</a>
								<br/><br/>
								<a href="#">Show More</a>
							</p>
							
						</div>
					</div>
					
					<div style="clear: both;">&nbsp;</div>
				</div>
				<!-- end #content -->
				<div id="sidebar">
					<ul>
						<li>
							<h2>Tag Decode:</h2>
							
							<div id="search1" >
								<form method="POST" action="#">
									<div>
										Tag ID(optional):<br/><input type="text" name="tagID" id="tagID" class="search-text" value="" /><br/>
										Tag Man Decode:<br/>
										<textarea cols="30" rows="10" class="search-text" id="mancode" name="mancode" ></textarea><br/>
										
										<input type="submit" class="search-submit" name="decodeTag" value="Decode" />
									</div>
								</form>
							</div>
							
							<br/>
						</li>
						
						<li>
							<h2>Tag Encode:</h2>
							<div id="search" >
								<form method="POST" action="#">
									<div>
										Tag ID (8 digits):<br/><input type="text" name="tagIDEncode" id="tagIDEncode" class="search-text" value="" /><br/>
										Manufacturer ID (2 digits hex):<br/><input type="text" name="manID" id="manID" class="search-text" value="" /><br/>
										
										<input type="submit" class="search-submit" name="encodeTag" value="Encode Tag" />
									</div>
								</form>
							</div>
							<br/><br/><br/><br/>
						</li>
					</ul>
				</div>
				<!-- end #sidebar -->
				<div style="clear: both;">&nbsp;</div>
			</div>
		</div>
	</div>
	<!-- end #page -->
</div>
<div id="footer">
	<!--<p>Copyright (c) 2012 Sitename.com. All rights reserved. Design by <a href="http://www.freecsstemplates.org">FCT</a>.</p>-->
</div>
<!-- end #footer -->
</body>
</html>
